using foundation_system.Data;
using foundation_system.Models;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;

namespace foundation_system.Controllers
{
    [Authorize]
    public class CategoriaGastoController : Controller
    {
        private readonly ApplicationDbContext _context;

        public CategoriaGastoController(ApplicationDbContext context)
        {
            _context = context;
        }

        // GET: CategoriaGasto
        public async Task<IActionResult> Index()
        {
            return View(await _context.CategoriasGastos.ToListAsync());
        }

        // GET: CategoriaGasto/Create
        public IActionResult Create()
        {
            return View();
        }

        // POST: CategoriaGasto/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("Id,Nombre,CodigoCuentaContable,Activo")] CategoriaGasto categoriaGasto)
        {
            if (ModelState.IsValid)
            {
                _context.Add(categoriaGasto);
                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index));
            }
            return View(categoriaGasto);
        }

        // GET: CategoriaGasto/Edit/5
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var categoriaGasto = await _context.CategoriasGastos.FindAsync(id);
            if (categoriaGasto == null)
            {
                return NotFound();
            }
            return View(categoriaGasto);
        }

        // POST: CategoriaGasto/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, [Bind("Id,Nombre,CodigoCuentaContable,Activo,CreadoEn")] CategoriaGasto categoriaGasto)
        {
            if (id != categoriaGasto.Id)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    _context.Update(categoriaGasto);
                    await _context.SaveChangesAsync();
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!CategoriaGastoExists(categoriaGasto.Id))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }
            return View(categoriaGasto);
        }

        private bool CategoriaGastoExists(int id)
        {
            return _context.CategoriasGastos.Any(e => e.Id == id);
        }
    }
}
